package javaclient;

import javax.swing.JDialog;
import javax.swing.JButton;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import javax.swing.JEditorPane;
import javax.swing.JTextField;
import javax.swing.JTable;
import javax.swing.table.*;
import org.xaira.server.*;
import javax.swing.JScrollPane;
import java.util.*;
/**
 * <p>Title: </p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2005</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */
public class Lemmata extends JDialog {
    public Lemmata() {
        try {
            jbInit();
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }

    public Lemmata(Frame f,Font tf) {
        super(f,"Lemmata",true);
        try {
            textfont=tf;
            jbInit();
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }

    private void jbInit() throws Exception {
        this.setTitle("Lemmata");
        this.getContentPane().setLayout(gridBagLayout1);
        jButton1.setText("OK");
        jButton1.addActionListener(new Lemmata_jButton1_actionAdapter(this));

        jEditorPane1.setText("");
        jButton2.setText("Words");
        jButton2.addActionListener(new Lemmata_jButton2_actionAdapter(this));

        jTable1.setPreferredScrollableViewportSize(new Dimension(500, 70));

        this.getContentPane().add(jButton1,
                                  new GridBagConstraints(1, 2, 1, 1, 0.0, 0.0
                , GridBagConstraints.CENTER, GridBagConstraints.NONE,
                new Insets(12, 259, 11, 65), 0, 0));
        this.getContentPane().add(jEditorPane1,
                                  new GridBagConstraints(0, 0, 2, 1, 1.0, 1.0
                , GridBagConstraints.CENTER, GridBagConstraints.BOTH,
                new Insets(20, 20, 0, 65), 0, 0));
        this.getContentPane().add(jButton2,
                                  new GridBagConstraints(0, 2, 1, 1, 0.0, 0.0
                , GridBagConstraints.CENTER, GridBagConstraints.NONE,
                new Insets(13, 20, 11, 0), 7, 3));
        this.getRootPane().setDefaultButton(jButton2);
        this.getContentPane().add(jScrollPane1,
                                  new GridBagConstraints(0, 1, 2, 1, 1.0, 1.0
                , GridBagConstraints.CENTER, GridBagConstraints.BOTH,
                new Insets(11, 20, 0, 65), -116, 73));
        if (textfont != null) {
            jEditorPane1.setFont(textfont);
            jTable1.setFont(textfont);
        }
        JTableHeader jH=jTable1.getTableHeader();
        jH.addMouseListener(new LemmaMouseAdapter());
    }

    JButton jButton1 = new JButton();
    JTextField jEditorPane1 = new JTextField();
    LemmataTableModel jWTab=new LemmataTableModel();
    JButton jButton2 = new JButton();
    XairoServer server=null;
    JTable jTable1 = new JTable(jWTab);
    JScrollPane jScrollPane1=new JScrollPane(jTable1);
    GridBagLayout gridBagLayout1 = new GridBagLayout();
    boolean bOK=false;
    String query="";
    Font textfont=null;

    public String getQuery()
    {
        if (!bOK) return null;
        return query;
    }

    public void jButton1_actionPerformed(ActionEvent e) {
        int s []=jTable1.getSelectedRows();
        int n=s.length;
        if (n==1) {
            bOK = true;
            query = "<lemma>" + jWTab.getValueAt(s[0],0) + "</lemma>";
        }
        else if (n > 1) {
            bOK=true;
            query="<or>";
            for (int i=0;i<n;i++) {
                query += "<lemma>" + jWTab.getValueAt(s[i],0) + "</lemma>";

            }
            query+="</or>";
        }
        dispose();
    }

    public void jButton2_actionPerformed(ActionEvent e) {
        String s=jEditorPane1.getText();
        XairoWordList l=null; int n=0;
        try {
            String [] sv=new String[1];
            sv[0]=s;
            l = server.getWordList(sv, "");
            if (l != null) n=l.getCount();
        }
        catch (XairoError err)
        {
            return;
        }
        if (l != null) jWTab.setWordlist(l);

    }
}

class LemmaMouseAdapter extends MouseAdapter
{
    public void mouseClicked(MouseEvent e)
    {
        JTableHeader h = (JTableHeader) e.getSource();
        TableColumnModel columnModel = h.getColumnModel();
        int viewColumn = columnModel.getColumnIndexAtX(e.getX());
        ((LemmataTableModel) h.getTable().getModel()).sort(viewColumn);
    }
}

class LemmataTableModel extends AbstractTableModel {
    public void setWordlist(XairoWordList l)
    {
        try {
            nrows = l.getCount();
            wd = new worddata[nrows];
            for (int i = 0; i < nrows; i++) {
                XairoWord w = l.getWord(i);
                wd[i]=new worddata();
                wd[i].norm = w.getNorm(0);
                wd[i].freq = w.getFrequency();
            }
        }
        catch (XairoError err)
        {
            nrows=0;
        }
        if (nrows > 0) fireTableRowsInserted(0,nrows-1);

    }

    int nrows=0;
    class worddata {
        String norm;
        int freq;
    }
    worddata [] wd=null;
    public String getColumnName(int col) {
        switch (col) {
        case 0:
            return "Word";
        case 1:
            return "Frequency";
        }
        return "";
    }

  public int getRowCount() {

     return nrows;
  }

  public int getColumnCount() { return 2; }

  public Object getValueAt(int row, int col) {
      Object ob="";
      worddata d=wd[row];
          if (col==0) ob=d.norm;
          else ob=new Integer(d.freq);
      return ob;
  }
  public Class getColumnClass(int i)
  {
      if (i==0) return String.class;
      else return Integer.class;
  }

  class LemmaComparator implements Comparator
  {
      public LemmaComparator(int col)
      {
          this.col=col;
      }
      int col=0;
      public int compare(Object ob1,Object ob2)
      {
          worddata w1=(worddata) ob1;
          worddata w2=(worddata) ob2;

          switch (col) {
          case 0:
              return w1.norm.compareTo(w2.norm);
          case 1:
              return w2.freq-w1.freq;
          }
          return 0;
      }
  }

  void sort(int col)
  {
      Arrays.sort(wd,new LemmaComparator(col));
      fireTableDataChanged();
  }

}




class Lemmata_jButton2_actionAdapter implements ActionListener {
    private Lemmata adaptee;
    Lemmata_jButton2_actionAdapter(Lemmata adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jButton2_actionPerformed(e);
    }
}


class Lemmata_jButton1_actionAdapter implements ActionListener {
    private Lemmata adaptee;
    Lemmata_jButton1_actionAdapter(Lemmata adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jButton1_actionPerformed(e);
    }
}
