package org.xaira.server;

import org.w3c.dom.*;
/**
 * <p>Title: </p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2005</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */
public class RPC {
    public RPC() {
    }


    static String StringParam(Element d,int i)
    {
        return RPC.String(RPC.Value(RPC.Param(d,i)));
    }

    static int IntParam(Element d,int i)
    {
        return RPC.Int(RPC.Value(RPC.Param(d,i)));
    }

    static boolean BoolParam(Element d,int i)
    {
        return RPC.Bool(RPC.Value(RPC.Param(d,i)));
    }

    static double DoubleParam(Element d,int i)
    {
        return RPC.Double(RPC.Value(RPC.Param(d,i)));
    }

    static String TextNode(Element d,String tag)
    {
        NodeList nl=d.getElementsByTagName(tag);
        int k=nl.getLength();
        if (k==0) return "";
        Node nd=nl.item(0);
        NodeList nd1=nd.getChildNodes();
        String tt="";
        for (int i=0;i<nd1.getLength();i++) {
            Node nt=nd1.item(i);
            if (nt.getNodeType() != Node.TEXT_NODE) continue;
            tt+=nt.getNodeValue();
        }
        return tt;
    }


    static String String(Element d)
    {
        return TextNode(d,"string");
    }

    static int Int(Element d)
    {
        return Integer.valueOf(TextNode(d,"i4")).intValue();
    }

    static double Double(Element d)
     {
         return Double.valueOf(TextNode(d,"double")).doubleValue();
     }


   static boolean Bool(Element d)
    {
        return Boolean.valueOf(TextNode(d,"boolean")).booleanValue();
    }

    static int[] VectorParam(Element d,int i)
    {
        return Vector(Value(Param(d,i)));
    }

    static int[] Vector(Element e)
    {
            NodeList nl=e.getElementsByTagName("data");
            if (nl.getLength()==0) return null;
            Element ex=(Element) nl.item(0);
            NodeList nll=ex.getChildNodes();
            int k=0;
            for (int i=0;i<nll.getLength();i++) {
                Node n=nll.item(i);
                if (n.getNodeType() != Node.ELEMENT_NODE) continue;
                    Element ne=(Element) n;
                    if (!ne.getTagName().equals("value")) continue;
                    k++;
            }
            int[] v=new int [k];
            k=0;
            for (int i=0;i<nll.getLength();i++) {
                    Node n=nll.item(i);
                    if (n.getNodeType() != Node.ELEMENT_NODE) continue;
                    Element ne=(Element) n;
                    if (!ne.getTagName().equals("value")) continue;
                    v[k++]=Int(ne);
            }
            return v;
    }



    static Element Value(Element d)
    {
        NodeList nl=d.getElementsByTagName("value");
        int k=nl.getLength();
        if (k==0) return null;
        Node nd=nl.item(0);
        return (Element) nd;
    }

    static String Name(Element d)
    {
        NodeList nl=d.getElementsByTagName("name");
        int k=nl.getLength();
        if (k==0) return null;
        Node nd=nl.item(0);
        NodeList nd1=nd.getChildNodes();
        String tt="";
        for (int i=0;i<nd1.getLength();i++) {
            Node nt=nd1.item(i);
            if (nt.getNodeType() != Node.TEXT_NODE) continue;
            tt+=nt.getNodeValue();
        }
        return tt;
    }

    static Element Struct(Element d)
    {
        NodeList nl=d.getElementsByTagName("struct");
        int k=nl.getLength();
        if (k==0) return null;
        Node nd=nl.item(0);
        return (Element) nd;

    }

    static Element Param(Element d,int n)
    {
        NodeList nl=d.getElementsByTagName("param");
        int k=nl.getLength();
        if (n >= k) return null;
        Node nd=nl.item(n);
        return (Element) nd;
    }

    static String Ret(int n,xmlrpc_arg  x[])
    {
        String p=Params(n,x);
        return "<methodResponse>" + p + "</methodResponse>";
    }

    static String Call(String m,int n,xmlrpc_arg[] x)
    {
        String p=Params(n,x);
        return "<methodCall><methodName>" + m + "</methodName>" + p + "</methodCall>";
    }

    static String Params(int n,xmlrpc_arg[] x)
    {
        String t="<params>";
        for (int i=0;i<n;i++) {
            switch (x[i].t) {
            case xmlrpc_arg.XMLRPC_STRING:
                t+="<param><value><string>"+RPC.Escape(x[i].s)+"</string></value></param>";
                break;
            case xmlrpc_arg.XMLRPC_I4:
                t+="<param><value><i4>"+x[i].i+"</i4></value></param>";
                break;
            case xmlrpc_arg.XMLRPC_BOOL:
                t+="<param><value><boolean>"+x[i].i+"</boolean></value></param>";
                break;
            case xmlrpc_arg.XMLRPC_DOUBLE:
                t+="<param><value><double>"+x[i].d+"</double></value></param>";
                break;
            case xmlrpc_arg.XMLRPC_VECTOR:
                t+="<param><value><array><data>";
                for (int j=0;j<x[i].vec.length;j++) {
                    t+="<value><i4>"+x[i].vec[j]+"</i4></value";
                }
                t+="</data></array></value></param>";
                break;
            case xmlrpc_arg.XMLRPC_VECTORS:
                t+="<param><value><array><data>";
                for (int j=0;j<x[i].vecs.length;j++) {
                    t+="<value><string>"+x[i].vecs[j]+"</string></value";
                }
                t+="</data></array></value></param>";
                break;
            }
        }
        t+="</params>";
        return t;
    }

    static String Escape(String s)
    {
        String ss="";
        for (int i=0;i<s.length();i++) {
            char c=s.charAt(i);
            if (c=='<') ss+="&lt;";
            else if (c=='&') ss+="&amp;";
            else ss+=c;
        }
        return ss;
    }



}
