package org.xaira.server;

import org.w3c.dom.*;

/**
 * <p>Title: </p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2005</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */
public class XairoGrammar {
    public XairoGrammar(XairoServer s) {
        m_server=s;
    }

    public int getNamespaceCount() throws XairoError
    {
        String s;
        org.w3c.dom.Element d;
        s=RPC.Call("Grammar_getNamespaceCount",0,null);
        d=m_server.RPCRemote(s);
        return RPC.IntParam(d,0);

    }

    public class Namespace
    {
        public Namespace(String url)
        {
             m_url = url;
        }

        public String getUrl()
        {
            return m_url;
        }
        String  m_url;
    };

    Namespace getNamespace(int i) throws XairoError
    {
        String s;
        org.w3c.dom.Element d;
        xmlrpc_arg x[]=new xmlrpc_arg[1];
        x[0]=new xmlrpc_arg(i);
        s=RPC.Call("Grammar_getNamespace",1,x);
        d=m_server.RPCRemote(s);
        String u=RPC.StringParam(d,0);
        return new Namespace(u);
    }

    public int getAddkeyCount() throws XairoError
    {
        String s;
        org.w3c.dom.Element d;
        s=RPC.Call("Grammar_getAddkeyCount",0,null);
        d=m_server.RPCRemote(s);
        return RPC.IntParam(d,0);
    }

    public class Addkey
    {
    public Addkey(String n,String g,boolean b)
    {
        m_name=n;
        m_gloss=g;
        m_bLemma=b;
    }

    public String getName()
    {
        return m_name;
    }

    public String  getGloss()
    {
        return m_gloss;
    }

    public boolean isLemmaScheme()
    {
        return m_bLemma;
    }

    String m_name, m_gloss;
    boolean m_bLemma;
    };

    Addkey getAddkey(int i) throws XairoError
    {
        String s;
        org.w3c.dom.Element d;
        xmlrpc_arg x[]=new xmlrpc_arg[1];
        x[0]=new xmlrpc_arg(i);
        s=RPC.Call("Grammar_getAddkey",1,x);
        d=m_server.RPCRemote(s);
        String n=RPC.StringParam(d,0);
        String g=RPC.StringParam(d,1);
        boolean b=RPC.BoolParam(d,2);
        return new Addkey(n,g,b);

    }

    public int getLemmaSchemeCount() throws XairoError
    {
        String s;
        org.w3c.dom.Element d;
        s=RPC.Call("Grammar_getLemmaSchemeCount",0,null);
        d=m_server.RPCRemote(s);
        return RPC.IntParam(d,0);
    }


    public class LemmaScheme
    {
        public LemmaScheme(String id,String n,String g,int nf,XairoServer s)
        {
            m_id=id;
            m_name=n;
            m_gloss=g;
            m_nfacets=nf;
            m_server=s;
        }

        public String getName()
        {
            return m_name;
        }

        public String getGloss()
        {
            return m_gloss;
        }

        public int getFacetCount()
        {
            return m_nfacets;
        }

        public String getFacet(int i) throws XairoError
        {
            String s;
            org.w3c.dom.Element d;
            xmlrpc_arg x[]=new xmlrpc_arg[2];
            x[0]=new xmlrpc_arg(m_id);
            x[1]=new xmlrpc_arg(i);
            s=RPC.Call("Grammar_LemmaScheme_getFacet",2,x);
            d=m_server.RPCRemote(s);
            return RPC.StringParam(d,0);

        }

        String m_id;
        String m_name;
        String m_gloss;
        int m_nfacets;
        XairoServer m_server;
    }

    public LemmaScheme getLemmaScheme(int i) throws XairoError
        {
            String s;
            org.w3c.dom.Element d;
            xmlrpc_arg x[]=new xmlrpc_arg[1];
            x[0]=new xmlrpc_arg(i);

          s=RPC.Call("Grammar_getLemmaScheme",1,x);
            d=m_server.RPCRemote(s);
            String id=RPC.StringParam(d,0);
            String n=RPC.StringParam(d,1);
            String g=RPC.StringParam(d,2);
            int nf=RPC.IntParam(d,4);
            return new LemmaScheme(id,n,g,nf,m_server);

        }

    public class Codebook
    {
        public Codebook(String id,XairoServer s)
        {
            m_id=id;
            m_server=s;

        }
    public String lookup(String s0) throws XairoError
    {
        String s;
        org.w3c.dom.Element d;
        xmlrpc_arg x[]=new xmlrpc_arg[2];
        x[0]=new xmlrpc_arg(m_id);
        x[1]=new xmlrpc_arg(s0);
        s=RPC.Call("Grammar_Codebook_lookup",2,x);
        d=m_server.RPCRemote(s);
        return RPC.StringParam(d,0);
    }

    String m_id;
    XairoServer m_server;

    };

    public class Attribute
    {
    public Attribute(String id,String n,String g,String url,String cb,String e,int ip,String target,boolean ib,XairoServer s)
    {
        m_id=id;
        m_name=n;
        m_gloss=g;
        m_url=url;
        m_cbid=cb;
        m_elt=e;
        m_ip=ip;
        m_target=target;
        m_inBib=ib;
        m_server=s;
    }

    public String getName()
    {
        return m_name;
    }

    public String getGloss()
    {
        return m_gloss;
    }

    public Namespace getNamespace()
    {
        return new Namespace(m_url);
    }

    public Codebook getCodebook()
    {
        return new Codebook(m_cbid,m_server);
    }

    public String getElt()
    {
        return m_elt;
    }

    public String getId()
    {
        return m_id;
    }

    public String getCBId()
    {
        return m_cbid;
    }

    public String getTarget()
    {
        return m_target;
    }

    public int getIP()
    {
        return m_ip;
    }

    public boolean inBib()
    {
        return m_inBib;
    }


    String m_id, m_name, m_gloss, m_url, m_cbid, m_elt, m_target;
    int m_ip;
    boolean m_inBib;
    XairoServer m_server;
    };

    public int getElementCount() throws XairoError
    {
        String s;
        org.w3c.dom.Element d;
        s=RPC.Call("Grammar_getElementCount",0,null);
        d=m_server.RPCRemote(s);
        return RPC.IntParam(d,0);
    }

    public class Element
    {
    public Element(String id,String n,String g,int ac,String url,XairoServer s)
    {
        m_id=id;
        m_name=n;
        m_gloss=g;
        m_natts=ac;
        m_url=url;
        m_server=s;
    }

    public String getName()
    {
        return m_name;
    }

    public String getGloss()
    {
        return m_gloss;
    }

    public int getAttributeCount()
    {
        return m_natts;
    }

    public Attribute getAttribute(int i) throws XairoError
    {
        String s;
        org.w3c.dom.Element d;
        xmlrpc_arg x[]=new xmlrpc_arg[2];
        x[0]=new xmlrpc_arg(m_id);
        x[1]=new xmlrpc_arg(i);
        s=RPC.Call("Grammar_getAttribute",2,x);
        d=m_server.RPCRemote(s);
        String id=RPC.StringParam(d,0);
        String n=RPC.StringParam(d,1);
        String g=RPC.StringParam(d,2);
        String u=RPC.StringParam(d,3);
        String c=RPC.StringParam(d,4);
        int ip=RPC.IntParam(d,5);
        String target=RPC.StringParam(d,6);
        boolean ib=RPC.BoolParam(d,7);
        return new Attribute(id,n,g,u,c,m_name,ip,target,ib,m_server);
    }

    public Namespace getNamespace()
    {
        return new Namespace(m_url);
    }
    String m_id,  m_name,  m_gloss, m_url;
    int m_natts;
    XairoServer m_server;
    };

    public Element getElement(int i) throws XairoError
    {
        String s;
        org.w3c.dom.Element d;
        xmlrpc_arg x[]=new xmlrpc_arg[1];
        x[0]=new xmlrpc_arg(i);
        s=RPC.Call("Grammar_getElement",1,x);
        d=m_server.RPCRemote(s);
        String id=RPC.StringParam(d,0);
        String n=RPC.StringParam(d,1);
        String g=RPC.StringParam(d,2);
        int ac=RPC.IntParam(d,3);
        String u=RPC.StringParam(d,4);
        return new Element(id,n,g,ac,u,m_server);

    }

    public int getGlobalAttributeCount() throws XairoError
    {
        String s;
        org.w3c.dom.Element d;
        s=RPC.Call("Grammar_getGlobalAttributeCount",0,null);
        d=m_server.RPCRemote(s);
        return RPC.IntParam(d,0);

    }
    public Attribute getGlobalAttribute(int i) throws XairoError
    {
        String s;
        org.w3c.dom.Element d;
        xmlrpc_arg x[]=new xmlrpc_arg[1];
        x[0]=new xmlrpc_arg(i);
        s=RPC.Call("Grammar_getGlobalAttribute",1,x);
        d=m_server.RPCRemote(s);
        String id=RPC.StringParam(d,0);
        String n=RPC.StringParam(d,1);
        String g=RPC.StringParam(d,2);
        String u=RPC.StringParam(d,3);
        String c=RPC.StringParam(d,4);
        int ip=RPC.IntParam(d,5);
        String target=RPC.StringParam(d,6);
        boolean ib=RPC.BoolParam(d,7);
        return new Attribute(id,n,g,u,c,"0",ip,target,ib,m_server);

    }

    public static class Partition
    {
        public Partition(String id,String  n,String  d,int c,boolean b,XairoServer s)
        {
            m_id = id;
            m_name = n;
            m_desc = d;
            m_count = c;
            m_bhasClasses = b;
            m_server = s;
        }

        public String  getName()
        {
            return m_name;
        }

        public String getDescription()
        {
            return m_desc;
        }

        public int getCount()
        {
            return m_count;
        }

        public Partition getDivision(int i) throws XairoError
        {
            String s;
            org.w3c.dom.Element d;
            xmlrpc_arg x[]=new xmlrpc_arg[2];
            x[0]=new xmlrpc_arg(m_id);
            x[1]=new xmlrpc_arg(i);
            s=RPC.Call("Grammar_Partition_getDivision",2,x);
            d=m_server.RPCRemote(s);
            String id=RPC.StringParam(d,0);
            String n=RPC.StringParam(d,1);
            String dx=RPC.StringParam(d,2);
            int c=RPC.IntParam(d,3);
            boolean b=RPC.BoolParam(d,4);
            return new Partition(id,n,dx,c,b,m_server);

        }

        public boolean hasClasses()
        {
            return m_bhasClasses;
        }

        public int getWordCount() throws XairoError
        {
            String s;
            org.w3c.dom.Element d;
            xmlrpc_arg x[]=new xmlrpc_arg[1];
            x[0]=new xmlrpc_arg(m_id);
            s=RPC.Call("Grammar_Partition_getWordCount",1,x);
            d=m_server.RPCRemote(s);
            return RPC.IntParam(d,0);
  }

        public String getId()
        {
            return m_id;
        }


        String m_id, m_name, m_desc;
        int m_count;
        boolean m_bhasClasses;
        XairoServer m_server;
    };

    public Partition getRootPartition() throws XairoError
    {
        String s;
        org.w3c.dom.Element d;
        s=RPC.Call("Grammar_getRootPartition",0,null);
        d=m_server.RPCRemote(s);
        String id=RPC.StringParam(d,0);
        String n=RPC.StringParam(d,1);
        String dx=RPC.StringParam(d,2);
        int c=RPC.IntParam(d,3);
        boolean b=RPC.BoolParam(d,4);
        return new Partition(id,n,dx,c,b,m_server);

    }


    XairoServer m_server;
}
