package org.xaira.server;

import java.io.*;
import org.xml.sax.*;
import javax.xml.parsers.*;
import org.w3c.dom.*;
import java.net.*;
/**
 * <p>Title: </p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2005</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */

public class XairoServer {

// initialisation

    public XairoServer() {
        m_grammar=new XairoGrammar(this);
    }

    public void Configure(String address,int port) throws XairoError
    {
        m_address=address;
        m_port=port;
        SocketStart();
        return;
    }

    String DoTransport(String s) throws XairoError
    {
        try {
            OutputStream ostr = m_socket.getOutputStream();
            byte b[] = s.getBytes("UTF-8");
            int bl=b.length;
            byte b1[]=new byte[bl+1];
            for (int i=0;i<bl;i++)
                b1[i]=b[i];
            b1[bl]=0;
            ostr.write(b1);
            InputStream istr = m_socket.getInputStream();
            String tt = "";
            while (true) {
                byte[] bb = new byte[5000];
                int k = istr.read(bb);
                int kk = k;
                boolean bEnd = false;
                if (k > 0 && bb[k - 1] == 0) {
                    bEnd = true;
                    kk = k - 1;
                }
                String t = new String(bb, 0, kk, "UTF-8");
                tt += t;
                if (bEnd)break;
            }
            return tt;
        }
        catch (IOException e)
        {
            throw new XairoError(XairoError.ERR_UNKNOWN,e.getMessage());
        }
    }

    public static class EH implements ErrorHandler
    {
        public void warning(SAXParseException e)
        {
        }
        public void error(SAXParseException e)
        {
        }
        public void fatalError(SAXParseException e)
        {
        }
    }

    public Element RPCRemote(String s) throws XairoError
    {
        DocumentBuilderFactory ff=DocumentBuilderFactory.newInstance();
        DocumentBuilder parser=null;
        try {
            parser = ff.newDocumentBuilder();
        }
        catch (ParserConfigurationException e)
        {
            throw new XairoError(XairoError.ERR_XMLRPC,"Cannot create parser: "+e.getMessage());
        }
        s=DoTransport(s);
        StringReader r=new StringReader(s);
        InputSource is=new InputSource(r);
        is.setEncoding("UTF-16");
        EH eh=new EH();
        parser.setErrorHandler(eh);
        Document doc;
        try {
                doc=parser.parse(is);
        }
        catch (SAXException e) {
                throw new XairoError(XairoError.ERR_XMLRPC,e.getMessage());
        }
        catch (IOException e) {
                throw new XairoError(XairoError.ERR_UNKNOWN,e.getMessage());
         }
        Element d=doc.getDocumentElement();
        NodeList l=d.getElementsByTagName("fault");
        if (l.getLength() != 0) {
                Element f=(Element) l.item(0);
                Element ss=RPC.Struct(RPC.Value(f));
                NodeList nl=ss.getElementsByTagName("member");
                String msg=""; int n=0;
                for (int i=0;i<nl.getLength();i++) {
                        Element m=(Element) nl.item(i);
                        if (RPC.Name(m).equals("faultString"))
                                msg=RPC.String(RPC.Value(m));
                        if (RPC.Name(m).equals("faultCode"))
                            n=RPC.Int(RPC.Value(m));


                }
                throw new XairoError(n,msg);
        }
        return d;
    }

// top level methods

    public XairoWordList getWordList(String re[],String l) throws XairoError
    {
            String s;
            Element d;
            xmlrpc_arg x[]=new xmlrpc_arg[2];
            x[0]=new xmlrpc_arg(re);
            x[1]=new xmlrpc_arg(l);
            s=RPC.Call("getWordList",2,x);
            d=RPCRemote(s);
            String id=RPC.StringParam(d,0);
            if (id.equals("null")) return null;
            return new XairoWordList(id,this);
    }

    public XairoWordList getFrequencyList(String re,int n,int m,int p,String l) throws XairoError
    {
        String s;
        Element d;
        xmlrpc_arg x[]=new xmlrpc_arg[5];
        x[0]=new xmlrpc_arg(re);
        x[1]=new xmlrpc_arg(n);
        x[2]=new xmlrpc_arg(m);
        x[3]=new xmlrpc_arg(p);
        x[4]=new xmlrpc_arg(l);
        s=RPC.Call("getFrequencyList",5,x);
        d=RPCRemote(s);
        return new XairoWordList(RPC.StringParam(d,0),this);
    }

    public XairoAttributeValueList getAttributeValueList(XairoGrammar.Attribute att) throws XairoError
    {
            String s;
            Element d;
            xmlrpc_arg x[]=new xmlrpc_arg[2];
            x[0]=new xmlrpc_arg(att.getId());
            x[1]=new xmlrpc_arg(att.getElt());
            String cbid=att.getCBId();
            s=RPC.Call("getAttributeValueList",2,x);
            d=RPCRemote(s);
            String id=RPC.StringParam(d,0);
            return new XairoAttributeValueList(id,cbid,this);
    }

    public XairoSolution solve(String q) throws XairoError
    {
        String s;
        Element d;
        xmlrpc_arg  x[]=new xmlrpc_arg[1];
        x[0]=new xmlrpc_arg(q);
        s=RPC.Call("solve",1,x);
        d=RPCRemote(s);
        String id=RPC.StringParam(d,0);
        if (id.equals("null")) return null;
        else return new XairoSolution(id,this);
    }



    public int getWordCount() throws XairoError
    {
        String s;
        Element d;
        s=RPC.Call("getWordCount",0,null);
        d=RPCRemote(s);
        return RPC.IntParam(d,0);
    }

    public String getCorpusName() throws XairoError
        {
            String s;
            Element d;
            s=RPC.Call("getCorpusName",0,null);
            d=RPCRemote(s);
            return RPC.StringParam(d,0);
        }

    public String getDefaultLanguage() throws XairoError
             {
                 String s;
                 Element d;
                 s=RPC.Call("getDefaultLanguage",0,null);
                 d=RPCRemote(s);
                 return RPC.StringParam(d,0);
             }

    public XairoCorpusTextList getCorpusTextList()
    {
            return new XairoCorpusTextList(this);
    }

    public XairoExtendedForm getUsage(int i)
    {
        return new XairoExtendedForm(i,this);
    }

// sockets transport

    void SocketStart() throws XairoError
    {
       try {
           m_socket = new Socket(InetAddress.getByName(m_address), m_port);
       }
       catch (IOException e)
       {
           throw new XairoError(XairoError.ERR_UNKNOWN,"Error connecting: "+e.getMessage());
       }
    }


    Socket m_socket;
    String m_address;
    int m_port;
    XairoGrammar m_grammar;
}
