package org.xaira.server;

import org.w3c.dom.Element;
/**
 * <p>Title: </p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2005</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */
public class XairoSolution {
    public XairoSolution(String id,XairoServer s) {
        m_id=id;
        m_server=s;
    }

    public int getCount() throws XairoError
{
        String s;
        Element d;
        xmlrpc_arg x[]=new xmlrpc_arg[1];
        x[0]=new xmlrpc_arg(m_id);
        s=RPC.Call("Solution_getCount",1,x);
        d=m_server.RPCRemote(s);
        return RPC.IntParam(d,0);
}

    public XairoHit getHit(int i) throws XairoError
    {
        String s;
        Element d;
        xmlrpc_arg x[]=new xmlrpc_arg[2];
        x[0]=new xmlrpc_arg(m_id);
        x[1]=new xmlrpc_arg(i);
        s=RPC.Call("Solution_getHit",2,x);
        d=m_server.RPCRemote(s);
        String u=RPC.StringParam(d,0);
        int doc=RPC.IntParam(d,1);
        int f=RPC.IntParam(d,2);
        String url=RPC.StringParam(d,3);
        int c1=RPC.IntParam(d,4);
        int c2=RPC.IntParam(d,5);
        return new XairoHit(m_id,i,u,doc,f,url,c1,c2,m_server);
    }

    public int getCorpusTextCount() throws XairoError
    {
        String s;
        Element d;
        xmlrpc_arg x[]=new xmlrpc_arg[1];
        x[0]=new xmlrpc_arg(m_id);
        s=RPC.Call("Solution_getCorpusTextCount",1,x);
        d=m_server.RPCRemote(s);
        return RPC.IntParam(d,0);
    }

    public XairoSolution thinInit(int n) throws XairoError
    {
        String s;
        Element d;
        xmlrpc_arg x[]=new xmlrpc_arg[2];
        x[0]=new xmlrpc_arg(m_id);
        x[1]=new xmlrpc_arg(n);
        s=RPC.Call("Solution_thinInit",2,x);
        d=m_server.RPCRemote(s);
        String id=RPC.StringParam(d,0);
        if (id.equals("null")) return null;
        else return new XairoSolution(id,m_server);
    }

    public XairoSolution thinRand(int n,int seed) throws XairoError
    {
        String s;
        Element d;
        xmlrpc_arg x[]=new xmlrpc_arg[3];
        x[0]=new xmlrpc_arg(m_id);
        x[1]=new xmlrpc_arg(n);
        x[2]=new xmlrpc_arg(seed);
        s=RPC.Call("Solution_thinRand",3,x);
        d=m_server.RPCRemote(s);
        String id=RPC.StringParam(d,0);
        if (id.equals("null")) return null;
        else return new XairoSolution(id,m_server);
    }

    public XairoSolution thinOnePerText() throws XairoError
    {
        String s;
        Element d;
        xmlrpc_arg x[]=new xmlrpc_arg[1];
        x[0]=new xmlrpc_arg(m_id);
        s=RPC.Call("Solution_thinOnePerText",1,x);
        d=m_server.RPCRemote(s);
        String id=RPC.StringParam(d,0);
        if (id.equals("null")) return null;
        else return new XairoSolution(id,m_server);
    }

    public XairoSolution thinSelection(int[] v) throws XairoError
    {
        String s;
        Element d;
        xmlrpc_arg x[]=new xmlrpc_arg[2];
        x[0]=new xmlrpc_arg(m_id);
        x[1]=new xmlrpc_arg(v);
        s=RPC.Call("Solution_thinSelection",2,x);
        d=m_server.RPCRemote(s);
        String id=RPC.StringParam(d,0);
        if (id.equals("null")) return null;
        else return new XairoSolution(id,m_server);
    }

    public XairoSolution thinCorpusTextFilter(XairoCorpusTextFilter f) throws XairoError
        {
            String s;
            Element d;
            xmlrpc_arg x[]=new xmlrpc_arg[2];
            x[0]=new xmlrpc_arg(m_id);
            x[1]=new xmlrpc_arg(f.getId());
            s=RPC.Call("Solution_thinCorpusTextFilter",2,x);
            d=m_server.RPCRemote(s);
            String id=RPC.StringParam(d,0);
            if (id.equals("null")) return null;
            else return new XairoSolution(id,m_server);
        }

    public static final int CM_Z=0;
    public static final int CM_MI=1;

    public class cwin {
        public cwin(int l,int r)
        {
            bX=false;
            l=wl;
            r=wr;
            s=ns="";
        }
        public cwin(String s,String ns)
        {
            bX=true;
            this.s=s;
            this.ns=ns;
            wl=wr=0;
        }
        boolean bX;
        int wl, wr;
        String s, ns;

    }

    public XairoCollocationTable makeCollocationTable(String pattern,String key,int m,cwin w,int maxn,double mins,double maxs,int lowf) throws XairoError
    {
        String s;
        Element d;
        xmlrpc_arg x[]=new xmlrpc_arg[13];
        x[0]=new xmlrpc_arg(m_id);
        x[1]=new xmlrpc_arg(pattern);
        x[2]=new xmlrpc_arg(key);
        x[3]=new xmlrpc_arg(m);
        x[4]=new xmlrpc_arg(w.bX);
        x[5]=new xmlrpc_arg(w.wl);
        x[6]=new xmlrpc_arg(w.wr);
        x[7]=new xmlrpc_arg(w.s);
        x[8]=new xmlrpc_arg(w.ns);
        x[9]=new xmlrpc_arg(maxn);
        x[10]=new xmlrpc_arg(mins);
        x[11]=new xmlrpc_arg(maxs);
        x[12]=new xmlrpc_arg(lowf);
        s=RPC.Call("Solution_makeCollocationTable",13,x);
        d=m_server.RPCRemote(s);
        String id=RPC.StringParam(d,0);
        if (id.equals("null")) return null;
        else return new XairoCollocationTable(id,m_server);
    }

    public XairoSolution thinCollocation(String key,cwin w,String[] sel) throws XairoError
    {
        String s;
        Element d;
        xmlrpc_arg x[]=new xmlrpc_arg[8];
        x[0]=new xmlrpc_arg(m_id);
        x[1]=new xmlrpc_arg(sel);
        x[2]=new xmlrpc_arg(key);
        x[3]=new xmlrpc_arg(w.bX);
        x[4]=new xmlrpc_arg(w.wl);
        x[5]=new xmlrpc_arg(w.wr);
        x[6]=new xmlrpc_arg(w.s);
        x[7]=new xmlrpc_arg(w.ns);
        s=RPC.Call("Solution_thinCollocation",8,x);
        d=m_server.RPCRemote(s);
        String id=RPC.StringParam(d,0);
        if (id.equals("null")) return null;
        else return new XairoSolution(id,m_server);
    }

    public int[] getAnalysis(int[] p,int max) throws XairoError
    {
        String s;
        Element d;
        xmlrpc_arg x[]=new xmlrpc_arg[3];
        x[0]=new xmlrpc_arg(m_id);
        x[1]=new xmlrpc_arg(p);
        x[2]=new xmlrpc_arg(max); // why?
        s=RPC.Call("Solution_getAnalysis",3,x);
        d=m_server.RPCRemote(s);
        return RPC.VectorParam(d,0);
}



    String m_id;
    XairoServer m_server;
}


