package org.xaira.server;

import org.w3c.dom.*;
/**
 * <p>Title: </p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2005</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */
public class XairoWord {
    public XairoWord(String id,XairoServer s) {
        m_id=id;
        m_server=s;
        m_bCache=false;
    }

    public XairoWord(String id,int f,int fc,String norm0,XairoServer s) {
        m_id=id;
        m_f=f;
        m_fc=fc;
        m_norm0=norm0;
        m_bCache=true;
        m_server=s;
    }

    public String getNorm(int n) throws XairoError
    {
        if (m_bCache && n==0) return m_norm0;
        String s;
        Element d;
        xmlrpc_arg x[]=new xmlrpc_arg[2];
        x[0]=new xmlrpc_arg(m_id);
        x[1]=new xmlrpc_arg(n);
        s=RPC.Call("Word_getNorm",2,x);
        d=m_server.RPCRemote(s);
        return RPC.StringParam(d,0);
    }

    public int getFrequency() throws XairoError
    {
        if (m_bCache) return m_f;
        String s;
        Element d;
        xmlrpc_arg x[]=new xmlrpc_arg[1];
        x[0]=new xmlrpc_arg(m_id);
        s=RPC.Call("Word_getFrequency",1,x);
        d=m_server.RPCRemote(s);
        return RPC.IntParam(d,0);
    }

    public int getFilteredFrequencyInSubcorpus(XairoCorpusTextFilter f) throws XairoError
    {
        String s;
        Element d;
        xmlrpc_arg x[]=new xmlrpc_arg[2];
        x[0]=new xmlrpc_arg(m_id);
        x[1]=new xmlrpc_arg(f.getId());
        s=RPC.Call("Word_getFilteredFrequency",2,x);
        d=m_server.RPCRemote(s);
        return RPC.IntParam(d,0);
    }

    public int getFormCount() throws XairoError
    {
        if (m_bCache) return m_fc;
        String s;
        Element d;
        xmlrpc_arg x[]=new xmlrpc_arg[1];
        x[0]=new xmlrpc_arg(m_id);
        s=RPC.Call("Word_getFormCount",1,x);
        d=m_server.RPCRemote(s);
        return RPC.IntParam(d,0);
    }

    public XairoForm getForm(int i) throws XairoError
{
        String s;
        Element d;
        xmlrpc_arg x[]=new xmlrpc_arg[2];
        x[0]=new xmlrpc_arg(m_id);
        x[1]=new xmlrpc_arg(i);
        s=RPC.Call("Word_getForm",2,x);
        d=m_server.RPCRemote(s);
        return new XairoForm(RPC.StringParam(d,0),m_server);
}

    String m_id;
    XairoServer m_server;
    int m_f, m_fc;
    String m_norm0;
    boolean m_bCache;
}
