// xaira-php.cpp : Defines the entry point for the DLL application.
//
#define _USE_32BIT_TIME_T 1

/* include standard header */ 
/* you will need to include this in all of your php extension projects*/ 
#define _CRT_SECURE_NO_DEPRECATE
#define _CRT_NON_CONFORMING_SWPRINTFS
#include "php.h" 
#include "php_ini.h"
#include "zend_exceptions.h"
#include "info.h"
typedef unsigned short xairo_uchar;
#include "XairoPHPError.h"

bool xairainit(const char*,const char*,const char*);
const char* gcn(int);
const char* gcp(int);
int gcc();
const char* _getCorpusName(void*);
void* _getWordList(void*,const char*,const char*);
void* _getUsage(void*,int);
int WordList_getCount(void*);
void* WordList_getWord(void*,int);
int Word_getFrequency(void*);
int Word_getFormCount(void*);
char* Word_getNorm(void*,int);
void* Word_getForm(void*,int);
char* Form_getNorm(void*);
char* Form_getText(void*);
int Form_getFrequency(void*);
char* Form_getAdditionalKey(void*,const char*);
char* CorpusText_getTitle(void*);
void* CorpusText_evalXpath(void*,const char*);
bool CorpusText_isSelected(void*,void*);
char* XpathValue_getText(void*);
int CorpusTextList_getCount(void*);
void* CorpusTextList_getCorpusText(void*,int);
void* CorpusTextList_getCorpusTextFilter(void*,int,int*);
void* _solve(void*,const char*);
void* Solution_getHit(void*,int);
void* Solution_thinCorpusTextFilter(void*,void*);
int Solution_getCount(void*);
char* Hit_getText(void*,int,int);
char* Hit_getUnit(void*);
void* Hit_getCorpusText(void*);
int Hit_getCursorStart(void*);
int Hit_getCursorEnd(void*);
void* _getServer(const char*);
void* _getGrammar(void*);
void* _getCorpusTextList(void*);
int Grammar_getAddkeyCount(void*);
char* GrammarAddkey_getName(void*);
bool GrammarAddkey_isLemmaScheme(void*);
void* Grammar_getAddkey(void*,int);
void* Solution_makeCollocationTable(void*,const char*,const char*,int,int,int,int,double,double,int);
void* Solution_makeCollocationTableX(void*,const char*,const char*,int,const char*,const char*,int,double,double,int);
int CollocationTable_getCount(void*);
void* CollocationTable_getCollocate(void*,int);
void* Collocate_getWord(void*);
int Collocate_getHits(void*);
double Collocate_getScore(void*);
int ExtendedForm_getType(void*);
char* ExtendedForm_getNorm(void*);
char* ExtendedForm_getText(void*);
void* _deserialize(void*,const char*);
char* Solution_serialize(void*);
char* CorpusTextFilter_serialize(void*);
char* _transcode(const char*);
char* _transcode2(const char*);
const char* _getTempPath();
const char* _getDataPath();

extern int kserver;

struct xaira_object {
	zend_object std;
	void* ptr;
	bool bInit;
	bool bDelete;
	xaira_object():ptr(NULL),bInit(false),bDelete(true) {}
};

extern "C" {

/* All the functions that will be exported (available) must be declared */ 

ZEND_FUNCTION(getXairaServer);

PHP_METHOD(XairaServer,getCorpusName); 
PHP_METHOD(XairaServer,getWordList);
PHP_METHOD(XairaServer,solve);
PHP_METHOD(XairaServer,getGrammar);
PHP_METHOD(XairaServer,getCorpusTextList);
PHP_METHOD(XairaServer,getUsage);
PHP_METHOD(XairaServer,deserialize);
PHP_METHOD(XairaServer,transcode);
PHP_METHOD(XairaServer,transcode2);
PHP_METHOD(XairaServer,getXairaServer);
PHP_METHOD(XairaServer,getXairaCorpora);


PHP_METHOD(XairoWordList,getCount);
PHP_METHOD(XairoWordList,getWord);

PHP_METHOD(XairoWord,getFrequency);
PHP_METHOD(XairoWord,getNorm);
PHP_METHOD(XairoWord,getFormCount);
PHP_METHOD(XairoWord,getForm);

PHP_METHOD(XairoForm,getNorm);
PHP_METHOD(XairoForm,getText);
PHP_METHOD(XairoForm,getAdditionalKey);
PHP_METHOD(XairoForm,getFrequency);

PHP_METHOD(XairoSolution,getCount);
PHP_METHOD(XairoSolution,getHit);
PHP_METHOD(XairoSolution,makeCollocationTable);
PHP_METHOD(XairoSolution,serialize);
PHP_METHOD(XairoSolution,thinCorpusTextFilter);


PHP_METHOD(XairoHit,getText);
PHP_METHOD(XairoHit,getHit);
PHP_METHOD(XairoHit,getCorpusText);
PHP_METHOD(XairoHit,getUnit);
PHP_METHOD(XairoHit,getCursorStart);
PHP_METHOD(XairoHit,getCursorEnd);

PHP_METHOD(XairoCorpusTextList,getCount);
PHP_METHOD(XairoCorpusTextList,getCorpusText);
PHP_METHOD(XairoCorpusTextList,getCorpusTextFilter);

PHP_METHOD(XairoCorpusTextFilter,serialize);

PHP_METHOD(XairoCorpusText,getTitle);
PHP_METHOD(XairoCorpusText,evalXpath);
PHP_METHOD(XairoCorpusText,isSelected);

PHP_METHOD(XairoXpathValue,getText);

PHP_METHOD(XairoGrammar,getAddkeyCount);
PHP_METHOD(XairoGrammar,getAddkey);

PHP_METHOD(XairoGrammarAddkey,getName);
PHP_METHOD(XairoGrammarAddkey,isLemmaScheme);

PHP_METHOD(XairoCollocationTable,getCount);
PHP_METHOD(XairoCollocationTable,getCollocate);

PHP_METHOD(XairoCollocate,getWord);
PHP_METHOD(XairoCollocate,getHits);
PHP_METHOD(XairoCollocate,getScore);

PHP_METHOD(XairoExtendedForm,getType);
PHP_METHOD(XairoExtendedForm,getNorm);
PHP_METHOD(XairoExtendedForm,getText);

PHP_MINFO_FUNCTION(xairamod); 
PHP_MINIT_FUNCTION(xairamod);




/* Just a basic int to be used as a counter*/ 
int i; 

PHP_INI_BEGIN()
PHP_INI_ENTRY("corpus_path","",PHP_INI_ALL,NULL)
PHP_INI_ENTRY("corpus_path2","",PHP_INI_ALL,NULL)
PHP_INI_ENTRY("corpus_path3","",PHP_INI_ALL,NULL)
PHP_INI_ENTRY("data_path","",PHP_INI_ALL,NULL)
PHP_INI_ENTRY("temp_path","",PHP_INI_ALL,NULL)
PHP_INI_END()

/* function list so that the Zend engine will know whats here */ 
zend_function_entry xairamod_functions[] = 
{ 
	ZEND_FE(getXairaServer, NULL)
	{NULL, NULL, NULL} 
}; 

zend_function_entry xaira_server_class_functions[] = 
{ PHP_ME(XairaServer,getCorpusName, NULL,ZEND_ACC_PUBLIC) 
  PHP_ME(XairaServer,getWordList, NULL,ZEND_ACC_PUBLIC) 
  PHP_ME(XairaServer,solve,NULL,ZEND_ACC_PUBLIC)
  PHP_ME(XairaServer,getGrammar,NULL,ZEND_ACC_PUBLIC)
  PHP_ME(XairaServer,getCorpusTextList,NULL,ZEND_ACC_PUBLIC)
  PHP_ME(XairaServer,getUsage,NULL,ZEND_ACC_PUBLIC)
  PHP_ME(XairaServer,deserialize,NULL,ZEND_ACC_PUBLIC)
  PHP_ME(XairaServer,transcode,NULL,ZEND_ACC_PUBLIC|ZEND_ACC_STATIC)
  PHP_ME(XairaServer,transcode2,NULL,ZEND_ACC_PUBLIC|ZEND_ACC_STATIC)
  PHP_ME(XairaServer,getXairaServer,NULL,ZEND_ACC_PUBLIC|ZEND_ACC_STATIC)
  PHP_ME(XairaServer,getXairaCorpora,NULL,ZEND_ACC_PUBLIC|ZEND_ACC_STATIC)
  {NULL, NULL, NULL} }; 

zend_function_entry xaira_wordlist_class_functions[] = 
{ PHP_ME(XairoWordList,getCount, NULL,ZEND_ACC_PUBLIC) 
  PHP_ME(XairoWordList,getWord, NULL,ZEND_ACC_PUBLIC) 
  {NULL, NULL, NULL} }; 



zend_function_entry xaira_word_class_functions[] = 
{ PHP_ME(XairoWord,getFrequency, NULL,ZEND_ACC_PUBLIC) 
  PHP_ME(XairoWord,getNorm, NULL,ZEND_ACC_PUBLIC) 
  PHP_ME(XairoWord,getFormCount, NULL,ZEND_ACC_PUBLIC) 
  PHP_ME(XairoWord,getForm, NULL,ZEND_ACC_PUBLIC) 
  {NULL, NULL, NULL} }; 

zend_function_entry xaira_xpathvalue_class_functions[] = 
{ PHP_ME(XairoXpathValue,getText, NULL,ZEND_ACC_PUBLIC) 
  {NULL, NULL, NULL} }; 

zend_function_entry xaira_form_class_functions[] = 
{ PHP_ME(XairoForm,getFrequency, NULL,ZEND_ACC_PUBLIC) 
  PHP_ME(XairoForm,getNorm, NULL,ZEND_ACC_PUBLIC) 
  PHP_ME(XairoForm,getText, NULL,ZEND_ACC_PUBLIC) 
  PHP_ME(XairoForm,getAdditionalKey, NULL,ZEND_ACC_PUBLIC) 
  {NULL, NULL, NULL} }; 

zend_function_entry xaira_solution_class_functions[] = 
{ PHP_ME(XairoSolution,getHit, NULL,ZEND_ACC_PUBLIC) 
  PHP_ME(XairoSolution,getCount, NULL,ZEND_ACC_PUBLIC) 
  PHP_ME(XairoSolution,makeCollocationTable,NULL,ZEND_ACC_PUBLIC)
  PHP_ME(XairoSolution,serialize,NULL,ZEND_ACC_PUBLIC)
  PHP_ME(XairoSolution,thinCorpusTextFilter,NULL,ZEND_ACC_PUBLIC)
  {NULL, NULL, NULL} }; 

zend_function_entry xaira_hit_class_functions[] = 
{ PHP_ME(XairoHit,getText, NULL,ZEND_ACC_PUBLIC)  
  PHP_ME(XairoHit,getUnit, NULL,ZEND_ACC_PUBLIC)
  PHP_ME(XairoHit,getCorpusText, NULL,ZEND_ACC_PUBLIC) 
  PHP_ME(XairoHit,getCursorStart, NULL,ZEND_ACC_PUBLIC) 
  PHP_ME(XairoHit,getCursorEnd, NULL,ZEND_ACC_PUBLIC) 
  {NULL, NULL, NULL} }; 

zend_function_entry xaira_corpustext_class_functions[] = 
{ PHP_ME(XairoCorpusText,getTitle, NULL,ZEND_ACC_PUBLIC)  
 PHP_ME(XairoCorpusText,evalXpath, NULL,ZEND_ACC_PUBLIC)  
 PHP_ME(XairoCorpusText,isSelected, NULL,ZEND_ACC_PUBLIC)  
  {NULL, NULL, NULL} }; 

zend_function_entry xaira_corpustextfilter_class_functions[] = 
{
  PHP_ME(XairoCorpusTextFilter,serialize,NULL,ZEND_ACC_PUBLIC)
	
	{NULL, NULL, NULL} }; 

zend_function_entry xaira_corpustextlist_class_functions[] = 
{ PHP_ME(XairoCorpusTextList,getCount, NULL,ZEND_ACC_PUBLIC)  
 PHP_ME(XairoCorpusTextList,getCorpusText, NULL,ZEND_ACC_PUBLIC)  
 PHP_ME(XairoCorpusTextList,getCorpusTextFilter, NULL,ZEND_ACC_PUBLIC)  
  {NULL, NULL, NULL} }; 

zend_function_entry xaira_grammar_class_functions[] = {
  PHP_ME(XairoGrammar,getAddkeyCount, NULL,ZEND_ACC_PUBLIC)  
  PHP_ME(XairoGrammar,getAddkey, NULL,ZEND_ACC_PUBLIC)  
  {NULL, NULL, NULL} }; 

zend_function_entry xaira_grammar_addkey_class_functions[] = {
  PHP_ME(XairoGrammarAddkey,getName, NULL,ZEND_ACC_PUBLIC)  
  PHP_ME(XairoGrammarAddkey,isLemmaScheme, NULL,ZEND_ACC_PUBLIC)  
  {NULL, NULL, NULL} }; 

zend_function_entry xaira_collocationtable_class_functions[] = {
  PHP_ME(XairoCollocationTable,getCount, NULL,ZEND_ACC_PUBLIC)  
  PHP_ME(XairoCollocationTable,getCollocate, NULL,ZEND_ACC_PUBLIC)  
  {NULL, NULL, NULL} }; 

  zend_function_entry xaira_collocate_class_functions[] = {
  PHP_ME(XairoCollocate,getWord, NULL,ZEND_ACC_PUBLIC)  
  PHP_ME(XairoCollocate,getHits, NULL,ZEND_ACC_PUBLIC)  
  PHP_ME(XairoCollocate,getScore, NULL,ZEND_ACC_PUBLIC)  
  {NULL, NULL, NULL} }; 

  zend_function_entry xaira_extendedform_class_functions[] = {
  PHP_ME(XairoExtendedForm,getType, NULL,ZEND_ACC_PUBLIC)  
  PHP_ME(XairoExtendedForm,getNorm, NULL,ZEND_ACC_PUBLIC)  
  PHP_ME(XairoExtendedForm,getText, NULL,ZEND_ACC_PUBLIC)  
  {NULL, NULL, NULL} }; 

zend_function_entry xaira_error_class_functions[] = 
{ {NULL, NULL, NULL} }; 

/* module information */ 
zend_module_entry xairamod_module_entry = 
{ STANDARD_MODULE_HEADER, 
"Xaira", 
xairamod_functions, 
PHP_MINIT(xairamod),
NULL, 
NULL, 
NULL, 
PHP_MINFO(xairamod), 
NO_VERSION_YET, 
STANDARD_MODULE_PROPERTIES }; 

#if COMPILE_DL_XAIRA_PHP 
ZEND_GET_MODULE(xairamod) 
#endif 

PHP_MINFO_FUNCTION(xairamod) 
{ 
	int i;
	php_info_print_table_start(); 
	for (i=0;i<gcc();i++) {
		char c[100]="Corpus ";
		strcat(c,gcn(i));
		php_info_print_table_row(2, c, gcp(i)); 
	}
	php_info_print_table_row(2, "Temporary path", _getTempPath()); 
	php_info_print_table_row(2, "DataPath", _getDataPath()); 
	php_info_print_table_end(); 
} 

zend_class_entry* ce_XairaServer;
zend_class_entry* ce_XairoWordList;
zend_class_entry* ce_XairoWord;
zend_class_entry* ce_XairoError;
zend_class_entry* ce_XairoSolution;
zend_class_entry* ce_XairoHit;
zend_class_entry* ce_XairoCorpusText;
zend_class_entry* ce_XairoCorpusTextFilter;
zend_class_entry* ce_XairoCorpusTextList;
zend_class_entry* ce_XairoForm;
zend_class_entry* ce_XairoGrammar;
zend_class_entry* ce_XairoGrammarAddkey;
zend_class_entry* ce_XairoCollocationTable;
zend_class_entry* ce_XairoCollocate;
zend_class_entry* ce_XairoExtendedForm;
zend_class_entry* ce_XairoXpathValue;

zend_object_handlers xaira_object_handlers;

void xaira_objects_clone(void *object, void **object_clone TSRMLS_DC)
{
	xaira_object* x=(xaira_object*) emalloc(sizeof(xaira_object));
	*x=*((xaira_object*) object);
	*object_clone=x;
}

void xperr(const char* s)
{
	zend_error(E_ERROR,s);
}

void except(const char* s TSRMLS_DC)
{
	zend_throw_exception(ce_XairoError,(char*) s,0 TSRMLS_CC);
}

zend_object_value xaira_server_objects_new(zend_class_entry *class_type TSRMLS_DC)
{
	zend_object_value retval;
	xaira_object* xo=(xaira_object*) emalloc(sizeof (xaira_object));
	xo->std.ce=class_type;
	xo->bInit=false;
	retval.handle = zend_objects_store_put(xo,NULL,NULL,xaira_objects_clone TSRMLS_CC);
	retval.handlers = &xaira_object_handlers;
	return retval;
}


PHP_MINIT_FUNCTION(xairamod) 
{ 
	REGISTER_INI_ENTRIES();
	memcpy(&xaira_object_handlers, zend_get_std_object_handlers(), sizeof(zend_object_handlers));
	zend_class_entry ce;
	INIT_CLASS_ENTRY(ce,"XairaServer",xaira_server_class_functions);
	ce.create_object = xaira_server_objects_new;
	ce_XairaServer=zend_register_internal_class(&ce TSRMLS_CC);
	INIT_CLASS_ENTRY(ce,"XairoWordList",xaira_wordlist_class_functions);
	ce.create_object = xaira_server_objects_new;
	ce_XairoWordList=zend_register_internal_class(&ce TSRMLS_CC);
	INIT_CLASS_ENTRY(ce,"XairoWord",xaira_word_class_functions);
	ce.create_object = xaira_server_objects_new;
	ce_XairoWord=zend_register_internal_class(&ce TSRMLS_CC);
	INIT_CLASS_ENTRY(ce,"XairoSolution",xaira_solution_class_functions);
	ce.create_object = xaira_server_objects_new;
	ce_XairoSolution=zend_register_internal_class(&ce TSRMLS_CC);
	INIT_CLASS_ENTRY(ce,"XairoHit",xaira_hit_class_functions);
	ce.create_object = xaira_server_objects_new;
	ce_XairoHit=zend_register_internal_class(&ce TSRMLS_CC);
	INIT_CLASS_ENTRY(ce,"XairoCorpusText",xaira_corpustext_class_functions);
	ce.create_object = xaira_server_objects_new;
	ce_XairoCorpusText=zend_register_internal_class(&ce TSRMLS_CC);
	INIT_CLASS_ENTRY(ce,"XairoCorpusTextFilter",xaira_corpustextfilter_class_functions);
	ce.create_object = xaira_server_objects_new;
	ce_XairoCorpusTextFilter=zend_register_internal_class(&ce TSRMLS_CC);
	INIT_CLASS_ENTRY(ce,"XairoCorpusTextList",xaira_corpustextlist_class_functions);
	ce.create_object = xaira_server_objects_new;
	ce_XairoCorpusTextList=zend_register_internal_class(&ce TSRMLS_CC);
	INIT_CLASS_ENTRY(ce,"XairoForm",xaira_form_class_functions);
	ce.create_object = xaira_server_objects_new;
	ce_XairoForm=zend_register_internal_class(&ce TSRMLS_CC);
	INIT_CLASS_ENTRY(ce,"XairoGrammar",xaira_grammar_class_functions);
	ce.create_object = xaira_server_objects_new;
	ce_XairoGrammar=zend_register_internal_class(&ce TSRMLS_CC);
	INIT_CLASS_ENTRY(ce,"XairoGrammarAddkey",xaira_grammar_addkey_class_functions);
	ce.create_object = xaira_server_objects_new;
	ce_XairoGrammarAddkey=zend_register_internal_class(&ce TSRMLS_CC);
	INIT_CLASS_ENTRY(ce,"XairoCollocationTable",xaira_collocationtable_class_functions);
	ce.create_object = xaira_server_objects_new;
	ce_XairoCollocationTable=zend_register_internal_class(&ce TSRMLS_CC);
	INIT_CLASS_ENTRY(ce,"XairoCollocate",xaira_collocate_class_functions);
	ce.create_object = xaira_server_objects_new;
	ce_XairoCollocate=zend_register_internal_class(&ce TSRMLS_CC);
	INIT_CLASS_ENTRY(ce,"XairoExtendedForm",xaira_extendedform_class_functions);
	ce.create_object = xaira_server_objects_new;
	ce_XairoExtendedForm=zend_register_internal_class(&ce TSRMLS_CC);
	INIT_CLASS_ENTRY(ce,"XairoXpathValue",xaira_xpathvalue_class_functions);
	ce.create_object = xaira_server_objects_new;
	ce_XairoXpathValue=zend_register_internal_class(&ce TSRMLS_CC);
	INIT_CLASS_ENTRY(ce, "XairoError", xaira_error_class_functions);
	ce_XairoError = zend_register_internal_class_ex(&ce, zend_exception_get_default(), NULL TSRMLS_CC);
	REGISTER_LONG_CONSTANT("XAIROCOLLOCATIONTABLE_CM_Z",0,CONST_CS|CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("XAIROCOLLOCATIONTABLE_CM_MI",1,CONST_CS|CONST_PERSISTENT);
	bool b=xairainit(INI_STR("corpus_path"),INI_STR("data_path"),INI_STR("temp_path"));
	if (b) 
		return SUCCESS;
	else
		return FAILURE;

} 

ZEND_FUNCTION(getXairaServer) { 
	if (ZEND_NUM_ARGS() > 1) WRONG_PARAM_COUNT;
	int k=0; char cn[100]; int na=0; cn[0]=0;
	zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC,"|s",&cn,&k);
	cn[k]=0;
	na=ZEND_NUM_ARGS();
//	void* v=na?_getServer(cn):_getServer(NULL);
	void* v=_getServer(NULL);
	if (v==NULL) {
		RETURN_NULL();
	}
	object_init_ex(return_value,ce_XairaServer);
	xaira_object* x=(xaira_object*) zend_objects_get_address(return_value TSRMLS_CC);
	x->ptr=v;
	x->bInit=true;
	return;
} 

PHP_METHOD(XairaServer,getXairaCorpora) { 
	int i;
	if (ZEND_NUM_ARGS() > 0) WRONG_PARAM_COUNT;
	array_init(return_value);
	for (i=0;i<gcc();i++) {
		char* key=(char*) gcn(i);
		char* path=(char*) gcp(i);
		add_assoc_string_ex(return_value,key,strlen(key)+1,path,1);
	}
	return;
} 

PHP_METHOD(XairaServer,getXairaServer) { 
	if (ZEND_NUM_ARGS() > 1) WRONG_PARAM_COUNT;
	int k=0; char* cn;
	zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC,"|s",&cn,&k);
	void* v=_getServer(cn);
	if (v==NULL) {
		RETURN_NULL();
	}
	object_init_ex(return_value,ce_XairaServer);
	xaira_object* x=(xaira_object*) zend_objects_get_address(return_value TSRMLS_CC);
	x->ptr=v;
	x->bInit=true;
	return;
} 



PHP_METHOD(XairaServer,getCorpusName) { 
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	void* v=xo->ptr;
	RETURN_STRING((char*) _getCorpusName(v),1);
}

PHP_METHOD(XairoSolution,getCount) { 
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	int n=Solution_getCount(xo->ptr);
	RETURN_LONG(n);
}

PHP_METHOD(XairoWordList,getCount) { 
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	int n=WordList_getCount(xo->ptr);
	RETURN_LONG(n);
}

PHP_METHOD(XairoWordList,getWord) { 
	if (ZEND_NUM_ARGS() != 1) WRONG_PARAM_COUNT;
	zval* id=getThis();
	int k;
	zend_parse_parameters(1 TSRMLS_CC,"l",&k);
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	void* w=WordList_getWord(xo->ptr,k);
	if (w==NULL) {
		RETURN_NULL();
	}
	object_init_ex(return_value,ce_XairoWord);
	xaira_object* x=(xaira_object*) zend_objects_get_address(return_value TSRMLS_CC);
	x->ptr=w;
	x->bInit=true;
	return;
}

PHP_METHOD(XairaServer,getWordList) { 
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	void* v=xo->ptr;
	if (ZEND_NUM_ARGS() == 0 || ZEND_NUM_ARGS() > 2) WRONG_PARAM_COUNT;
	char* s; int ls; char* l=""; int ll;
	zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC,"s|s",&s,&ls,&l,&ll);
	void* vv;
	try {
		vv=_getWordList(v,s,l);
	}
	catch (CXairoPHPError* e)
	{
		except(e->getMessage() TSRMLS_CC);
	}
	if (vv==NULL) {
		RETURN_NULL();
	}
	object_init_ex(return_value,ce_XairoWordList);
	xaira_object* x=(xaira_object*) zend_objects_get_address(return_value TSRMLS_CC);
	x->ptr=vv;
	x->bInit=true;
	return;
}

PHP_METHOD(XairaServer,getUsage) { 
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	void* v=xo->ptr;
	if (ZEND_NUM_ARGS() != 1) WRONG_PARAM_COUNT;
	int i;
	zend_parse_parameters(1 TSRMLS_CC,"l",&i);
	void* vv;
	vv=_getUsage(v,i);
	if (vv==NULL) {
		RETURN_NULL();
	}
	object_init_ex(return_value,ce_XairoExtendedForm);
	xaira_object* x=(xaira_object*) zend_objects_get_address(return_value TSRMLS_CC);
	x->ptr=vv;
	x->bInit=true;
	return;
}

PHP_METHOD(XairaServer,solve) { 
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	void* v=xo->ptr;
	if (ZEND_NUM_ARGS() != 1) WRONG_PARAM_COUNT;
	char* s; int ls;
	zend_parse_parameters(1 TSRMLS_CC,"s",&s,&ls);
	void* vv;
	try {
		vv=_solve(v,s);
	}
	catch (CXairoPHPError* e)
	{
		except(e->getMessage() TSRMLS_CC);
	}
	if (vv==NULL) {
		RETURN_NULL();
	}
	object_init_ex(return_value,ce_XairoSolution);
	xaira_object* x=(xaira_object*) zend_objects_get_address(return_value TSRMLS_CC);
	x->ptr=vv;
	x->bInit=true;
	return;
}

PHP_METHOD(XairaServer,deserialize) { 
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	void* v=xo->ptr;
	if (ZEND_NUM_ARGS() != 1) WRONG_PARAM_COUNT;
	char* s; int ls;
	zend_parse_parameters(1 TSRMLS_CC,"s",&s,&ls);
	void* vv;
	vv=_deserialize(v,s);
	if (strncmp(s,"sol",3)==0)
		object_init_ex(return_value,ce_XairoSolution);
	else if (strncmp(s,"ctf",3)==0)
		object_init_ex(return_value,ce_XairoCorpusTextFilter);
	else except("Cannot deserialize Xairo object" TSRMLS_CC);
	xaira_object* x=(xaira_object*) zend_objects_get_address(return_value TSRMLS_CC);
	x->ptr=vv;
	x->bInit=true;
	return;
}

PHP_METHOD(XairaServer,getGrammar) { 
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	void* v=xo->ptr;
	void* vv;
	vv=_getGrammar(v);
	object_init_ex(return_value,ce_XairoGrammar);
	xaira_object* x=(xaira_object*) zend_objects_get_address(return_value TSRMLS_CC);
	x->ptr=vv;
	x->bInit=true;
	x->bDelete=false;
	return;
}

PHP_METHOD(XairaServer,getCorpusTextList) { 
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	void* v=xo->ptr;
	void* vv;
	vv=_getCorpusTextList(v);
	object_init_ex(return_value,ce_XairoCorpusTextList);
	xaira_object* x=(xaira_object*) zend_objects_get_address(return_value TSRMLS_CC);
	x->ptr=vv;
	x->bInit=true;
	return;
}

PHP_METHOD(XairoSolution,getHit) { 
	if (ZEND_NUM_ARGS() != 1) WRONG_PARAM_COUNT;
	int k;
	zend_parse_parameters(1 TSRMLS_CC,"l",&k);
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	void* v;
	try {
		v=Solution_getHit(xo->ptr,k);
	}
	catch (CXairoPHPError* e)
	{
		except(e->getMessage() TSRMLS_CC);
	}
	if (v==NULL) {
		RETURN_NULL();
	}
	object_init_ex(return_value,ce_XairoHit);
	xaira_object* x=(xaira_object*) zend_objects_get_address(return_value TSRMLS_CC);
	x->ptr=v;
	x->bInit=true;
	return;
}

PHP_METHOD(XairoSolution,thinCorpusTextFilter) { 
	if (ZEND_NUM_ARGS() != 1) WRONG_PARAM_COUNT;
	zval* idf;
	zend_parse_parameters(1 TSRMLS_CC,"O",&idf,ce_XairoCorpusTextFilter);
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	xaira_object* xof=(xaira_object*) zend_object_store_get_object(idf TSRMLS_CC);
	void* v;
	try {
		v=Solution_thinCorpusTextFilter(xo->ptr,xof->ptr);
	}
	catch (CXairoPHPError* e)
	{
		except(e->getMessage() TSRMLS_CC);
	}
	if (v==NULL) {
		RETURN_NULL();
	}
	object_init_ex(return_value,ce_XairoSolution);
	xaira_object* x=(xaira_object*) zend_objects_get_address(return_value TSRMLS_CC);
	x->ptr=v;
	x->bInit=true;
	return;
}

PHP_METHOD(XairoSolution,serialize) { 
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	char* c=Solution_serialize(xo->ptr);
	RETURN_STRING(c,1);
}

PHP_METHOD(XairoSolution,makeCollocationTable) { 
	if (ZEND_NUM_ARGS() > 8) WRONG_PARAM_COUNT;// make some optional
	char* pattern=".*"; char* key=""; int lp, lk;
	int method=0; zval* window=NULL;
	int maxn=20, lowf=0;
	double mins=-1E50, maxs=1E50;
	zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC,"|sslalddl",&pattern,&lp,
		&key,&lk,&method,&window,
		&maxn,&mins,&maxs,&lowf);
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	HashTable* htab=NULL;
	if (window) htab=Z_ARRVAL_P(window);
	bool bX=false;
	int winl=3, winr=3; char* el, *ns;
	zval** kv;
	if (htab && zend_hash_find(htab,"bX",sizeof("bX"),(void**) &kv)==SUCCESS)
		bX=Z_LVAL_PP(kv) != 0;
	void* v;
	if (!bX) {
		if (htab && zend_hash_find(htab,"wl",sizeof("wl"),(void**) &kv)==SUCCESS)
			winl=Z_LVAL_PP(kv);
		if (htab && zend_hash_find(htab,"wr",sizeof("wr"),(void**) &kv)==SUCCESS)
			winr=Z_LVAL_PP(kv);
		v=Solution_makeCollocationTable(xo->ptr,pattern,key,method,winl,winr,
			maxn,mins,maxs,lowf);
	}
	else { 
		if (htab && zend_hash_find(htab,"s",sizeof("s"),(void**) &kv)==SUCCESS)
			el=Z_STRVAL_PP(kv);
		if (htab && zend_hash_find(htab,"ns",sizeof("ns"),(void**) &kv)==SUCCESS)
			ns=Z_STRVAL_PP(kv);
		v=Solution_makeCollocationTableX(xo->ptr,pattern,key,method,el,ns,
			maxn,mins,maxs,lowf);
	}

	if (v==NULL) {
		RETURN_NULL();
	}
	object_init_ex(return_value,ce_XairoCollocationTable);
	xaira_object* x=(xaira_object*) zend_objects_get_address(return_value TSRMLS_CC);
	x->ptr=v;
	x->bInit=true;
	return;
}

PHP_METHOD(XairoCollocationTable,getCount) { 
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	int n=CollocationTable_getCount(xo->ptr);
	RETURN_LONG(n);
}

PHP_METHOD(XairoCollocationTable,getCollocate) { 
	if (ZEND_NUM_ARGS() != 1) WRONG_PARAM_COUNT;
	int k;
	zend_parse_parameters(1 TSRMLS_CC,"l",&k);
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	void* v=CollocationTable_getCollocate(xo->ptr,k);
	object_init_ex(return_value,ce_XairoCollocate);
	xaira_object* x=(xaira_object*) zend_objects_get_address(return_value TSRMLS_CC);
	x->ptr=v;
	x->bInit=true;
	return;
}

PHP_METHOD(XairoWord,getFrequency) { 
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	int n=Word_getFrequency(xo->ptr);
	RETURN_LONG(n);
}

PHP_METHOD(XairoWord,getFormCount) { 
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	int n=Word_getFormCount(xo->ptr);
	RETURN_LONG(n);
}

PHP_METHOD(XairoWord,getNorm) { 
	if (ZEND_NUM_ARGS() != 1) WRONG_PARAM_COUNT;
	int k;
	zend_parse_parameters(1 TSRMLS_CC,"l",&k);
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	char* c=Word_getNorm(xo->ptr,k);
	RETURN_STRING(c,1);
}

PHP_METHOD(XairoWord,getForm) { 
	if (ZEND_NUM_ARGS() != 1) WRONG_PARAM_COUNT;
	int k;
	zend_parse_parameters(1 TSRMLS_CC,"l",&k);
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	void* v=Word_getForm(xo->ptr,k);
	object_init_ex(return_value,ce_XairoForm);
	xaira_object* x=(xaira_object*) zend_objects_get_address(return_value TSRMLS_CC);
	x->ptr=v;
	x->bInit=true;
	return;
}

PHP_METHOD(XairoForm,getNorm) { 
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	char* c=Form_getNorm(xo->ptr);
	RETURN_STRING(c,1);
}

PHP_METHOD(XairoForm,getText) { 
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	char* c=Form_getText(xo->ptr);
	RETURN_STRING(c,1);
}

PHP_METHOD(XairoForm,getFrequency) { 
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	int n=Form_getFrequency(xo->ptr);
	RETURN_LONG(n);
}

PHP_METHOD(XairoForm,getAdditionalKey) { 
	if (ZEND_NUM_ARGS() != 1) WRONG_PARAM_COUNT;
	char* s; int ls;
	zend_parse_parameters(1 TSRMLS_CC,"s",&s,&ls);
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	char* ss=Form_getAdditionalKey(xo->ptr,s);
	RETURN_STRING(ss,1);
}


PHP_METHOD(XairoHit,getText) { 
	if (ZEND_NUM_ARGS() != 2) WRONG_PARAM_COUNT;
	int n=0; int m=-1;
	zend_parse_parameters(2 TSRMLS_CC,"ll",&n,&m);
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	char* c=Hit_getText(xo->ptr,n,m);
	RETURN_STRING(c,1);
}

PHP_METHOD(XairoHit,getCorpusText) { 
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	void* v=Hit_getCorpusText(xo->ptr);
	object_init_ex(return_value,ce_XairoCorpusText);
	xaira_object* x=(xaira_object*) zend_objects_get_address(return_value TSRMLS_CC);
	x->ptr=v;
	x->bInit=true;
	return;
}

PHP_METHOD(XairoHit,getUnit) { 
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	char* c=Hit_getUnit(xo->ptr);
	RETURN_STRING(c,1);
}

PHP_METHOD(XairoHit,getCursorStart) { 
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	int i=Hit_getCursorStart(xo->ptr);
	RETURN_LONG(i);
}

PHP_METHOD(XairoHit,getCursorEnd) { 
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	int i=Hit_getCursorEnd(xo->ptr);
	RETURN_LONG(i);
}

PHP_METHOD(XairoCorpusText,getTitle) { 
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	char* c=CorpusText_getTitle(xo->ptr);
	RETURN_STRING(c,1);
}

PHP_METHOD(XairoCorpusText,evalXpath) { 
	if (ZEND_NUM_ARGS() != 1) WRONG_PARAM_COUNT;
	char* s; int ls;
	zend_parse_parameters(1 TSRMLS_CC,"s",&s,&ls);
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	void* v;
	try {
		v=CorpusText_evalXpath(xo->ptr,s);
	}
	catch (CXairoPHPError* e)
	{
		except(e->getMessage() TSRMLS_CC);
	}
	if (v==NULL) {
		RETURN_NULL();
	}
	object_init_ex(return_value,ce_XairoXpathValue);
	xaira_object* x=(xaira_object*) zend_objects_get_address(return_value TSRMLS_CC);
	x->ptr=v;
	x->bInit=true;
	return;
}

PHP_METHOD(XairoCorpusText,isSelected) { 
	if (ZEND_NUM_ARGS() != 1) WRONG_PARAM_COUNT;
	zval* idf;
	zend_parse_parameters(1 TSRMLS_CC,"O",&idf,ce_XairoCorpusTextFilter);
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	xaira_object* xof=(xaira_object*) zend_object_store_get_object(idf TSRMLS_CC);
	bool b=CorpusText_isSelected(xo->ptr,xof->ptr);
	RETURN_BOOL(b?1:0);
}


PHP_METHOD(XairoCorpusTextList,getCount) { 
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	int n=CorpusTextList_getCount(xo->ptr);
	RETURN_LONG(n);
}

PHP_METHOD(XairoCorpusTextList,getCorpusText) { 
	if (ZEND_NUM_ARGS() != 1) WRONG_PARAM_COUNT;
	zval* id=getThis();
	int k;
	zend_parse_parameters(1 TSRMLS_CC,"l",&k);
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	void* t=CorpusTextList_getCorpusText(xo->ptr,k);
	if (t==NULL) {
		RETURN_NULL();
	}
	object_init_ex(return_value,ce_XairoCorpusText);
	xaira_object* x=(xaira_object*) zend_objects_get_address(return_value TSRMLS_CC);
	x->ptr=t;
	x->bInit=true;
	return;
}

PHP_METHOD(XairoCorpusTextFilter,serialize) { 
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	char* c=CorpusTextFilter_serialize(xo->ptr);
	RETURN_STRING(c,1);
}

PHP_METHOD(XairoCorpusTextList,getCorpusTextFilter) { 
	if (ZEND_NUM_ARGS() != 1) WRONG_PARAM_COUNT;
	zval* id=getThis();
	zval* a;
	zend_parse_parameters(1 TSRMLS_CC,"a",&a);
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	HashTable* hta=a->value.ht;
	int nt=zend_hash_num_elements(hta);
	int* t=new int [nt];
	for (int i=0;i<nt;i++) {
		zval** x;
		zend_hash_index_find(hta,i,(void**) &x);
		t[i]=Z_LVAL_PP(x);
	}
	void* f=CorpusTextList_getCorpusTextFilter(xo->ptr,nt,t);
	if (f==NULL) {
		RETURN_NULL();
	}
	object_init_ex(return_value,ce_XairoCorpusTextFilter);
	xaira_object* x=(xaira_object*) zend_objects_get_address(return_value TSRMLS_CC);
	x->ptr=f;
	x->bInit=true;
	return;
}

PHP_METHOD(XairoGrammar,getAddkeyCount) { 
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	int n=Grammar_getAddkeyCount(xo->ptr);
	RETURN_LONG(n);
}

PHP_METHOD(XairoGrammar,getAddkey) { 
	if (ZEND_NUM_ARGS() != 1) WRONG_PARAM_COUNT;
	int k;
	zend_parse_parameters(1 TSRMLS_CC,"l",&k);
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	void* v=Grammar_getAddkey(xo->ptr,k);
	object_init_ex(return_value,ce_XairoGrammarAddkey);
	xaira_object* x=(xaira_object*) zend_objects_get_address(return_value TSRMLS_CC);
	x->ptr=v;
	x->bInit=true;
	x->bDelete=false;
	return;
}



PHP_METHOD(XairoGrammarAddkey,getName) { 
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	char* s=GrammarAddkey_getName(xo->ptr);
	RETURN_STRING(s,1);
}

PHP_METHOD(XairoGrammarAddkey,isLemmaScheme) { 
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	bool b=GrammarAddkey_isLemmaScheme(xo->ptr);
	RETURN_BOOL(b);
}

PHP_METHOD(XairoCollocate,getWord) { 
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	void* v=Collocate_getWord(xo->ptr);
	object_init_ex(return_value,ce_XairoWord);
	xaira_object* x=(xaira_object*) zend_objects_get_address(return_value TSRMLS_CC);
	x->ptr=v;
	x->bInit=true;
	return;
}


PHP_METHOD(XairoCollocate,getHits) { 
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	int n=Collocate_getHits(xo->ptr);
	RETURN_LONG(n);
}

PHP_METHOD(XairoCollocate,getScore) { 
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	double d=Collocate_getScore(xo->ptr);
	RETURN_DOUBLE(d);
}

PHP_METHOD(XairoExtendedForm,getType) { 
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	int d=ExtendedForm_getType(xo->ptr);
	RETURN_LONG(d);
}

PHP_METHOD(XairoExtendedForm,getNorm) { 
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	char* c=ExtendedForm_getNorm(xo->ptr);
	RETURN_STRING(c,1);
}

PHP_METHOD(XairoExtendedForm,getText) { 
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	char* c=ExtendedForm_getText(xo->ptr);
	RETURN_STRING(c,1);
}

PHP_METHOD(XairoXpathValue,getText) { 
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	char* s=XpathValue_getText(xo->ptr);
	RETURN_STRING(s,1);
}

PHP_METHOD(XairaServer,transcode) { 
	if (ZEND_NUM_ARGS() != 1) WRONG_PARAM_COUNT;
	char* s; int ls;
	zend_parse_parameters(1 TSRMLS_CC,"s",&s,&ls);
	char* w=_transcode(s);
	RETURN_STRING(w,1);
}


PHP_METHOD(XairaServer,transcode2) { 
	if (ZEND_NUM_ARGS() != 1) WRONG_PARAM_COUNT;
	char* s; int ls;
	zend_parse_parameters(1 TSRMLS_CC,"s",&s,&ls);
	char* w=_transcode2(s);
	RETURN_STRING(w,1);
}



}

#ifdef _WIN32
//#include "windows.h"
BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
    return TRUE;
}

#endif
