/*
 * This file was auto-generated by the Axis C++ Web Service Generator (WSDL2Ws)
 * This file contains definitions of the web service
 *
 * File subsequently edited to add methods. If you regenerate the source from revised
 * wsdl, you must not use the new Xaira.cpp or Xaira.hpp files to overwrite the
 * existing files but must merge them in. 
 */

#include <stdio.h>
#include <stdarg.h>

#ifndef _WIN32
#define _MAX_PATH 128
#else
#include <windows.h>
#include <direct.h>
#endif

#include "Xaira.hpp"
#include "../XairoHeader.h"

using namespace XAIRO_NAMESPACE;

xairo_uchar* uc(const char* s);
char* utf8(const xairo_uchar*);

Xaira::Xaira()
{
}

Xaira::~Xaira()
{
}

class CSOAPXairoBootMonitor : public CXairoIBootMonitor
{
public :
	CSOAPXairoBootMonitor(Xaira* c):m_server(c) {}
	void Log(const xairo_uchar*);
	Xaira* m_server;
};

void CSOAPXairoBootMonitor::Log(const xairo_uchar* s)
{
	m_server->note(utf8(s));
}

void Xaira::note(const char* s,...)
{
	va_list l;
	va_start(l,s);
	FILE* f=fopen(m_log,"a");
	vfprintf(f,s,l);
	fprintf(f,"\n");
	fclose(f);
	va_end(l);
}

/* This function is called by the AxisEngine when something went wrong
 with the current web service request processing. Appropriate actions should
 be taken here.*/
void Xaira::onFault()
{
}
/* This function is called by the AxisEngine when this web service
 library is first loaded. So here we can initialize any global/static
 data structures of this web service or open database connections */
#ifndef _WIN32
#define CONFNAME "/etc/Xaira.conf"
#else
#define CONFNAME "/axis/conf/Xaira.conf"
#endif
#define MAXPARAM 128
#define PARAM_CORPUSPATH "CorpusPath"
#define PARAM_LOGPATH "LogPath"

void Xaira::init()
{
	if (m_bLoaded) {
		note("Server running");
		return;
	}
	char p[_MAX_PATH];
#ifndef _WIN32
	char* env=getenv("AXISCPP_DEPLOY");
	if (env) strcpy(p,env);
	else strcpy(p,"/usr/local/axiscpp_deploy");
	strcat(p,CONFNAME);
#else
	getcwd(p,_MAX_PATH);
	strcat(p,CONFNAME);
#endif
	FILE* f=fopen(p,"r");
	if (f==NULL) return;
	char* pp=NULL; char* lp=NULL;
	while (fgets(p,_MAX_PATH,f)) {
		char param[MAXPARAM];
		if (p[0]=='#') continue;
		int k=0;
		int x=sscanf(p,"%128[a-zA-Z] : %n",param,&k);
		if (x==0) continue;
		if (strcmp(param,PARAM_CORPUSPATH) == 0) {
			pp=strdup(p+k);
			int y=(int) strlen(pp)-1;
			while (y && isspace(pp[y]) ) y--;
			pp[y+1]=0;
		}
		else if (strcmp(param,PARAM_LOGPATH) == 0) {
			lp=strdup(p+k);
			int y=(int) strlen(lp)-1;
			while (y && isspace(lp[y])) y--;
			lp[y+1]=0;
		}
	}
	fclose(f);
	m_log=new char [_MAX_PATH];
#ifndef _WIN32
	if (env) strcpy(m_log,env);
	else strcpy(m_log,"/usr/local/axiscpp_deploy");
	strcat(m_log,"/log/XairaLog");
#else
	strcpy(m_log,"XairaLog.txt");
#endif
	if (lp) 
		strcpy(m_log,lp);
	if (pp==NULL) return;
	note (pp);
	CSOAPXairoBootMonitor b(this);
	CXairoIParameters xp;
	xp.parameter_file=pp;
	xp.bm=&b;
	xp.inth=NULL;
#ifdef _WIN32
	char tp[_MAX_PATH];
	GetTempPathA(_MAX_PATH,tp);
	xp.temppath=tp;
	char dp[_MAX_PATH];
	GetModuleFileNameA(NULL,dp,_MAX_PATH);
	char* x=strrchr(dp,'\\');
	*x=0;
	xp.datapath=dp;
#else
	xp.temppath="/tmp";
	xp.datapath="";
#endif
	m_server=CXairoImplementation::getServer(&xp);
	if (m_server==NULL) return;
	note("Started server");
	m_bLoaded=true;
}
/* This function is called by the AxisEngine when this web service
 library is unloaded. So we can deallocate any global/static data structures
 and close database connections etc here. */
void Xaira::fini()
{
}
hit_Array Xaira::solve(xsd__string s)  
{
	hit_Array x;
	CXairoISolution* sol=NULL;
	int n=0;
	try {
		sol=m_server->solve(uc(s));
		if (sol) n=sol->getCount();
	}
	catch (CXairoIError* e)
	{
		XairaFault* f=new XairaFault;
		f->msg=utf8(e->getMessage());
		note("fault: %s",f->msg);
		throw f;
	}
	catch (...)
	{
		note("gfault");
		throw;
	}
	x.m_Size=n;
	hit * a=new hit [n];
	for (int i=0;i<n;i++) {
		CXairoIHit* h=NULL;
		try {
			h=sol->getHit(i);
		}
		catch (...)
		{
		}
		char* x;
		if (h) x=utf8(h->getText(0,1000)); else x="Error";

//		note(x);
		a[i].text=x;
		a[i].offset=0; // obsolete but still in wsdl
		a[i].length=0;
		a[i].doc=h?utf8(h->getCorpusText()->getTitle()):(char*) "";
		a[i].unit=h?utf8(h->getUnit()):(char*) "";
	}
	x.m_Array=a;
	return x;
}

static xairo_uchar s_dot_star[]={'.','*',0};
static xairo_uchar s_[]={0};

collocate_Array Xaira::collocation(xsd__string w, xsd__int m, xsd__int wl, xsd__int wr)  
{
	note("collocation");
	collocate_Array c;
	c.m_Size=0;
	c.m_Array=NULL;
	CXairoISolution* sol=NULL;
	int n=0;
	try {
		sol=m_server->solve(uc(w));
		if (sol) n=sol->getCount();
	}
	catch (CXairoIError* e)
	{
		note("fault");
		XairaFault* f=new XairaFault;
		f->msg=utf8(e->getMessage());
		throw f;
	}
	catch (...)
	{
		note("gfault");
		throw;
	}
	note("%d solutions",n);
	if (sol==NULL) return c;
	CXairoICollocationTable* t=sol->makeCollocationTable(s_dot_star,s_,(CXairoICollocationTable::cmeth) m,CXairoICollocationTable::_cwin(wl,wr),1000,-1000.0,1000.0,0);
	n=t->getCount();
	note("%d collocates",n);
	c.m_Size=n;
	c.m_Array=new collocate [n];
	for (int i=0;i<n;i++) {
		CXairoICollocate* coll=t->getCollocate(i);
		c.m_Array[i].word=utf8(coll->getWord());
		c.m_Array[i].hits=coll->getHits();
		c.m_Array[i].frequency=coll->getFreq();
		c.m_Array[i].score=coll->getScore();
	}
	return c;
}

word_Array Xaira::getWordList(xsd__string s)  
{
	word_Array x;
	CXairoIWordList* wl=NULL;
	int n=0;
	try {
		wl=m_server->getWordList(uc(s),s_);
		if (wl) n=wl->getCount();
	}
	catch (CXairoIError* e)
	{
		note("fault");
		XairaFault* f=new XairaFault;
		f->msg=utf8(e->getMessage());
		throw f;
	}
	catch (...)
	{
		note("gfault");
	}
	x.m_Size=n;
	word * a=new word [n];
	for (int i=0;i<n;i++) {
		CXairoIWord* h=wl->getWord(i);
		char* x=utf8(h->getNorm());
//		note(x);
		a[i].norm=x;
//		a[i].text=utf8(L"\x3db\x3ba");
		a[i].frequency=h->getFrequency();
	}
	x.m_Array=a;
	return x;
}


formlistelement_Array Xaira::getFormList(xsd__string Value0)  
{
	formlistelement_Array f;
	f.m_Size=0;
	int n=0;
	CXairoIWordList* wl=m_server->getWordList(uc(Value0),s_);
	if (wl) n=wl->getCount();
	if (n==0) return f;
	CXairoIWord* w=wl->getWord(0);
	int m=w->getFormCount();
	f.m_Size=m;
	f.m_Array=new formlistelement [m];
	const CXairoIGrammar* g=m_server->getGrammar();
	int na=g->getAddkeyCount();
	int t=0;
	for (int j=0;j<na;j++) {
		const CXairoIGrammar::Addkey* ak=g->getAddkey(j);
		if (!ak->isLemmaScheme()) t++;
	}
	const xairo_uchar** names=new const xairo_uchar* [t];
	t=0;
	for (int j=0;j<na;j++) {
		const CXairoIGrammar::Addkey* ak=g->getAddkey(j);
		if (!ak->isLemmaScheme()) {
			names[t]=ak->getName();
			t++;
		}
	}
	for (int i=0;i<m;i++) {
		CXairoIForm* fo=w->getForm(i);
		f.m_Array[i].norm=utf8(fo->getNorm());
		f.m_Array[i].frequency=fo->getFrequency();
		f.m_Array[i].form.m_Size=t;
		f.m_Array[i].form.m_Array=new addkeyvalue [t];
		for (int j=0;j<t;j++) {
			f.m_Array[i].form.m_Array[j].addkey=utf8(names[j]);
			f.m_Array[i].form.m_Array[j].addkeyval=utf8(fo->getAdditionalKey(names[j]));
		}
	}
	delete [] names;
	return f;
}
